<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>4.1.2 Arrays of Arrays (``Multidimensional'' Arrays)</title>
<link href="sx4aa.html" rev=precedes>
<link href="sx4b.html" rel=precedes>
<link href="sx4a.html" rev=subdocument>
</head>
<body>
<H3>4.1.2 Arrays of Arrays (``Multidimensional'' Arrays)</H3>

<p>[This section is optional and may be skipped.]
</p><p>When we said that ``Arrays are not limited to type <TT>int</TT>;
you can have arrays of... any other type,''
we meant that more literally than you might have guessed.
If you have an ``array of <TT>int</TT>,''
it means that you have an array
each of whose elements is of type <TT>int</TT>.
But you can have an array each of whose elements is of type <I>x</I>,
where <I>x</I> is any type you choose.
In particular,
you can have an array each of whose elements is another array!
We can use these arrays of arrays for the same sorts of tasks
as we'd use multidimensional arrays in other computer languages
(or matrices in mathematics).
Naturally, we are not limited to arrays of arrays,
either;
we could have an array of arrays of arrays,
which would
act like
a 3-dimensional array, etc.
</p><p>The declaration of an array of arrays looks like this:
<pre>
	int a2[5][7];
</pre>
You have to read complicated declarations like these ``inside out.''
What this one says is that <TT>a2</TT> is an array of 5 somethings,
and that each of the somethings is an array of 7 <TT>int</TT>s.
More briefly,
``<TT>a2</TT> is an array of 5 arrays of 7 <TT>int</TT>s,''
or,
``<TT>a2</TT> is an array of array of <TT>int</TT>.''
In the declaration of <TT>a2</TT>,
the brackets closest to the identifier <TT>a2</TT>
tell you what <TT>a2</TT> first and foremost is.
That's how you know it's an array of 5 arrays of size 7,
not the other way around.
You can think of <TT>a2</TT>
as having 5 ``rows'' and 7 ``columns,''
although this interpretation is not mandatory.
(You could also treat the ``first'' or inner subscript
as ``x'' and the second as ``y.''
Unless you're doing something fancy,
all you have to worry about
is that the subscripts when you access the array
match those that you used when you declared it,
as in the examples below.)
</p><p>To illustrate the use of multidimensional arrays,
we might fill in the elements of the above array <TT>a2</TT>
using this piece of code:
<pre>
	int i, j;
	for(i = 0; i &lt; 5; i = i + 1)
		{
		for(j = 0; j &lt; 7; j = j + 1)
			a2[i][j] = 10 * i + j;
		}
</pre>
This pair of nested loops sets <TT>a[1][2]</TT> to 12,
<TT>a[4][1]</TT> to 41, etc.
Since the first
dimension of <TT>a2</TT> is 5,
the first
subscripting index variable, <TT>i</TT>,
runs from 0 to 4.
Similarly, the second
subscript varies from 0 to 6.
</p><p>We could print <TT>a2</TT> out
(in a two-dimensional way,
suggesting its structure)
with a similar pair of nested loops:
<pre>
	for(i = 0; i &lt; 5; i = i + 1)
		{
		for(j = 0; j &lt; 7; j = j + 1)
			printf("%d\t", a2[i][j]);
		printf("\n");
		}
</pre>
(The character <TT>\t</TT> in the <TT>printf</TT> string
is the tab character.)
</p><p>Just to see more clearly what's going on,
we could make the ``row'' and ``column''
subscripts explicit by printing them, too:
<pre>
	for(j = 0; j &lt; 7; j = j + 1)
		printf("\t%d:", j);
	printf("\n");

	for(i = 0; i &lt; 5; i = i + 1)
		{
		printf("%d:", i);
		for(j = 0; j &lt; 7; j = j + 1)
			printf("\t%d", a2[i][j]);
		printf("\n");
		}
</pre>
This last fragment would print
<pre>
        0:      1:      2:      3:      4:      5:      6:
0:      0       1       2       3       4       5       6
1:      10      11      12      13      14      15      16
2:      20      21      22      23      24      25      26
3:      30      31      32      33      34      35      36
4:      40      41      42      43      44      45      46
</pre>
</p><p>Finally,
there's no reason we have to loop over the ``rows'' first
and the ``columns'' second;
depending on what we wanted to do, we could interchange the two loops,
like this:
<pre>
	for(j = 0; j &lt; 7; j = j + 1)
		{
		for(i = 0; i &lt; 5; i = i + 1)
			printf("%d\t", a2[i][j]);
		printf("\n");
		}
</pre>
Notice that <TT>i</TT> is still the first subscript
and it still runs from 0 to 4,
and <TT>j</TT> is still the second subscript
and it still runs from 0 to 6.
</p><hr>
<p>
Read sequentially:
<a href="sx4aa.html" rev=precedes>prev</a>
<a href="sx4b.html" rel=precedes>next</a>
<a href="sx4a.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995-1997
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
